Coin: SoPickAction Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoPickAction Class Reference
Action Classes

The SoPickAction class is the base class for picking actions. More...

`#include <Inventor/actions/SoPickAction.h>`

Inheritance diagram for SoPickAction:

## Public Member Functions
virtual SoType | getTypeId (void) const
void | setViewportRegion (const SbViewportRegion &newregion)
const SbViewportRegion & | getViewportRegion (void) const
void | enableCulling (const SbBool flag)
SbBool | isCullingEnabled (void) const
Public Member Functions inherited from SoAction
virtual | ~SoAction (void)
virtual SbBool | isOfType (SoType type) const
virtual void | apply (SoNode *root)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
void | apply (SoAction *beingApplied)
virtual void | invalidateState (void)
AppliedCode | getWhatAppliedTo (void) const
SoNode * | getNodeAppliedTo (void) const
SoPath * | getPathAppliedTo (void) const
const SoPathList * | getPathListAppliedTo (void) const
const SoPathList * | getOriginalPathListAppliedTo (void) const
SbBool | isLastPathListAppliedTo (void) const
PathCode | getPathCode (int &numindices, const int *&indices)
void | traverse (SoNode *const node)
SbBool | hasTerminated (void) const
const SoPath * | getCurPath (void)
SoState * | getState (void) const
PathCode | getCurPathCode (void) const
virtual SoNode * | getCurPathTail (void)
void | usePathCode (int &numindices, const int *&indices)
void | pushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (const PathCode prevpathcode)
void | pushCurPath (void)
void | popPushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (void)
void | switchToPathTraversal (SoPath *path)
void | switchToNodeTraversal (SoNode *node)

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoAction
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)
static void | nullAction (SoAction *action, SoNode *node)

## Protected Member Functions
virtual const SoEnabledElementsList & | getEnabledElements (void) const
| SoPickAction (const SbViewportRegion &viewportregion)
virtual | ~SoPickAction (void)
virtual void | beginTraversal (SoNode *node)
Protected Member Functions inherited from SoAction
| SoAction (void)
virtual void | endTraversal (SoNode *node)
void | setTerminated (const SbBool flag)
virtual SbBool | shouldCompactPathList (void) const

## Static Protected Member Functions
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)

## Protected Attributes
SbViewportRegion | vpRegion
Protected Attributes inherited from SoAction
SoState * | state
SoActionMethodList * | traversalMethods

## Additional Inherited Members
Public Types inherited from SoAction
enum | AppliedCode { NODE = 0 , PATH = 1 , PATH_LIST = 2 }
enum | PathCode { NO_PATH = 0 , IN_PATH = 1 , BELOW_PATH = 2 , OFF_PATH = 3 }

## Detailed Description

The SoPickAction class is the base class for picking actions.

The basis for all interaction features that Coin provides for the application programmer is the pick actions. Draggers, manipulators, SoSelection nodes, etc all make use of the functionality provided by the pick actions for selecting and manipulating scene geometry in various ways.

This class is not supposed to be used directly by the application programmer, as it is more a placeholder for the common interface of picking operations. It does not contain any actual code for doing scene graph picks.

Coin provides a fully functional picking action for the application programmer to use through the SoRayPickAction class (which inherits the SoPickAction class).

See also
  SoSelection

## Constructor & Destructor Documentation

## ◆ SoPickAction()

SoPickAction::SoPickAction | ( | const SbViewportRegion & | viewportregion | ) |
| protected

Constructor.

## ◆ ~SoPickAction()

SoPickAction::~SoPickAction | ( | void |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoPickAction::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and "downward" casting.

Implements SoAction.

Reimplemented in SoRayPickAction.

## ◆ getClassTypeId()

SoType SoPickAction::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ addMethod()

void SoPickAction::addMethod | ( | const SoType | type,
|  | SoActionMethod | method )
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ enableElement()

void SoPickAction::enableElement | ( | const SoType | type,
|  | const int | stackindex )
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ getEnabledElements()

const SoEnabledElementsList & SoPickAction::getEnabledElements | ( | void |  | ) | const
| protectedvirtual

Returns list of enabled elements.

Reimplemented from SoAction.

Reimplemented in SoRayPickAction.

## ◆ getClassEnabledElements()

SoEnabledElementsList * SoPickAction::getClassEnabledElements | ( | void |  | ) |
| staticprotected

Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ getClassActionMethods()

SoActionMethodList * SoPickAction::getClassActionMethods | ( | void |  | ) |
| staticprotected

Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ initClass()

void SoPickAction::initClass | ( | void |  | ) |
| static

Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

## ◆ setViewportRegion()

void SoPickAction::setViewportRegion | ( | const SbViewportRegion & | newregion | ) |

Set a new viewport region to replace the one passed in with the constructor.

## ◆ getViewportRegion()

const SbViewportRegion & SoPickAction::getViewportRegion | ( | void |  | ) | const

Returns the viewport region used by the action.

## ◆ enableCulling()

void SoPickAction::enableCulling | ( | const SbBool | flag | ) |

Don't calculate bounding boxes and try to do culling when picking.

This can provide a speed-up in cases where the default setting of `on` would be inefficient.

## ◆ isCullingEnabled()

SbBool SoPickAction::isCullingEnabled | ( | void |  | ) | const

Returns the current state of the culling flag.

## ◆ beginTraversal()

void SoPickAction::beginTraversal | ( | SoNode * | node | ) |
| protectedvirtual

This virtual method is called from SoAction::apply(), and is the entry point for the actual scene graph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scene graph traversal.

Reimplemented from SoAction.

Reimplemented in SoRayPickAction.

## Member Data Documentation

## ◆ vpRegion

SbViewportRegion SoPickAction::vpRegion
| protected

The viewport region used by pick actions.

The documentation for this class was generated from the following files:

- SoPickAction.h
- SoPickAction.cpp